"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformReply = exports.transformArguments = void 0;
const generic_transformers_1 = require("./generic-transformers");
function transformArguments(key, objectOrMap) {
    var _a, _b;
    const flattenArgs = (_b = (_a = mapArgumentTransformer(key, objectOrMap)) !== null && _a !== void 0 ? _a : objectArgumentTransformer(key, objectOrMap)) !== null && _b !== void 0 ? _b : [];
    // TODO: add support for tuples
    flattenArgs.unshift('HSET');
    return flattenArgs;
}
exports.transformArguments = transformArguments;
function mapArgumentTransformer(key, map) {
    if (!(map instanceof Map))
        return;
    const flat = [key];
    for (const [key, value] of map.entries()) {
        flat.push(key.toString(), value.toString());
    }
    return flat;
}
function isObject(obj) {
    return typeof obj === 'object' && obj !== null && !Array.isArray(obj);
}
function objectArgumentTransformer(key, obj) {
    if (!isObject(obj)) {
        return;
    }
    const flat = [key];
    for (const key of Object.keys(obj)) {
        flat.push(key.toString(), obj[key].toString());
    }
    return flat;
}
exports.transformReply = generic_transformers_1.transformReplyString;
