"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformReply = exports.transformArguments = exports.IS_READ_ONLY = exports.FIRST_KEY_INDEX = void 0;
const generic_transformers_1 = require("./generic-transformers");
exports.FIRST_KEY_INDEX = 2;
exports.IS_READ_ONLY = true;
function transformArguments(keys, options) {
    const args = ['ZINTER'];
    if (typeof keys === 'string') {
        args.push('1', keys);
    }
    else {
        args.push(keys.length.toString(), ...keys);
    }
    if (options === null || options === void 0 ? void 0 : options.WEIGHTS) {
        args.push('WEIGHTS', ...options.WEIGHTS.map(weight => weight.toString()));
    }
    if (options === null || options === void 0 ? void 0 : options.AGGREGATE) {
        args.push('AGGREGATE', options === null || options === void 0 ? void 0 : options.AGGREGATE);
    }
    return args;
}
exports.transformArguments = transformArguments;
exports.transformReply = generic_transformers_1.transformReplyStringArray;
